#(VtgJIS japanese-shift-jis-dos is used)
# MVFX : Music Visual Effects (tentative name), a sketch of Ripples.
#
# by: zhuo   http://geocities.yahoo.co.jp/gl/zhuoware
#
# Special Thanks to:
#     KonekoP - for precious advice 
# 
# Rev. 0.15   May 31-Jun 4, 2008 zhuo
# 	      - KonekoP's patch marged, thanks a lot!
#             - Spectrum Scope, as an example of "scope" concept
#               - snapshot listing with colored background.
#             - operations inside the list,tentative:
#               - left-click toggles select-unselect.
#               - right-click opens a menu with "delete" and
#                 "transparent" which operates on the selected items.
#                 *** NOTE: TRANSPARENTIZE IS VERY SLOW. TAKES 
#                 SEVERAL SECONDS PER AN ITEM. ***
#               - left-drag to change the order of the snapshots.
#                 Note that the snapshots below <hidden> item are 
#                 not shown.
#             - you can open the spectrum scope by  a right-click
#               on the waveform. In the menu, choose "ext scope: spectrum." 
#             - Choose "show spectrogram" in the same menu to
#               have the spectrogram, in which a left click shoots
#               the snapshot of the spectrum. 
#
# Rev. 0.14-b3 branch on May 25-26, 2008 zhuo
#             - snapshot listing
# Rev. 0.14-b2 branch on May 24, 2008 zhuo
#             - spectrum snapshot.
# Rev. 0.14-b1 branch on May 22-23, 2008 zhuo
#             - spectrum scope. 
#             - patch from KonekoP; "wm protocol" has been taken in.
#               - japanese menu / automatic run / SMF BPM, are yet to be done
# Rev. 0.14   May 21-, 2008 zhuo
#             - to do: 
#             - value print around cursor
#             - event generation from loudness
# Rev. 0.13   May 19, 2008 zhuo
#             - formant display added.
# Rev. 0.12   May 14-18, 2008 zhuo
#             - pitch: all pitch-related values shown
#             - shuttle move --- so far grasping move is implemented;
#                                Try Ctrl + left-button + drag 
#             - ripples --- a bit better graphics management
#             - cursor: cursor location in sec shown
# Rev. 0.11   May 13, 2008  zhuo
#             - loudness : windowsize is now wider, to apply smoothing.
#             - pitch: window size is wider, for smoothing.
#             -        Also, 0.7 * (new input) + 0.3 * (prev output)
#                      (naiive low-pass) is inserted.
# Rev. 0.10   May 11, 2008  zhuo
#             - SMF: CC#8 was used by mistake; Now CC#11 is used, correctly. 
#                    scaling for expression adjusted by try-and-error.
# Rev. 0.09   May 10, 2008  zhuo 
#             - playback functionality
#                 left press in waveform - hold - release
# Rev. 0.08   May 9, 2008  zhuo
#             - loudness scaling now applied in SMF-dump only
#             - vertical cursor introduced
#             - text dump introduced
# Rev. 0.07   May 6, 2008  zhuo
# Rev. 0.06   May 5, 2008  zhuo
# Rev. 0.05   May 3, 2008  zhuo
# Rev. 0.02   April 6, 2008  zhuo

####################
# tentative test: generate rgb
####################
source "Colors.tcl"


######################################################################
# package dependencies
######################################################################
package require BWidget
package require snack 2.2
package require Img

######################################################################
# global constants
######################################################################
set MVFXSysAttr(MVFXVersion) "0.15"
set MVFXSysAttr(dir) [pwd]

########################################
# VIEWER SECTION
# ... to be split into components ...
########################################
set MVFXVizAttr(mainW) 2048
set MVFXVizAttr(mainH) 1024
set MVFXVizAttr(mainWinH) 320


set MVFXVizAttr(panelWinW) 160
set MVFXVizAttr(panelLeft) 0
set MVFXVizAttr(panelRight) 480
set MVFXVizAttr(panelTop) 0
set MVFXVizAttr(panelBottom) $MVFXVizAttr(mainH)
set MVFXVizAttr(panelBGColor) black
set MVFXVizAttr(panelFont) {Ariel 9}

set MVFXVizAttr(scaleWinH) 20
set MVFXVizAttr(scaleLeft) 0
set MVFXVizAttr(scaleRight) $MVFXVizAttr(mainW)
set MVFXVizAttr(scaleTop) 0
set MVFXVizAttr(scaleBottom) $MVFXVizAttr(scaleWinH)
set MVFXVizAttr(scaleTickTall) 7
set MVFXVizAttr(scaleTickShort) 4
set MVFXVizAttr(scaleBGColor) "\#404040"
set MVFXVizAttr(scaleFGColor) "\#d0d0e0"
set MVFXVizAttr(scaleHighlightColor) "\#ffe8e8"
set MVFXVizAttr(scaleFont) {Ariel 8}

set MVFXVizAttr(dispLeft) 0
set MVFXVizAttr(dispTop) 0
set MVFXVizAttr(dispRight) $MVFXVizAttr(mainW)
set MVFXVizAttr(dispBottom) $MVFXVizAttr(mainH)

set MVFXVizAttr(dispWinW) 640
set MVFXVizAttr(dispBackGroundColor) black

set MVFXVizAttr(dispWaveformFillColor) yellow
set MVFXVizAttr(dispWaveformHeightPixel) 96
set MVFXVizAttr(dispWaveformSubsample) 25
set MVFXVizAttr(dispPixelsPerSecond) 250

set MVFXVizAttr(dispSpectrogramColorMap) {}
for { set i 0 } { $i < 256 } { set i [expr $i+1] } {
    lappend MVFXVizAttr(dispSpectrogramColorMap) [format "\#%02x%02x00" $i $i]
}
set MVFXVizAttr(dispSpectrogramHeightPixel) 384
set MVFXVizAttr(dispSpectrogramTopFreq) 22050

## 4096 crashes for a long audio track
#set MVFXVizAttr(dispSpectrogramFFTLength) 4096
#set MVFXVizAttr(dispSpectrogramWindowLength) 4096
set MVFXVizAttr(dispSpectrogramFFTLength) 2048
set MVFXVizAttr(dispSpectrogramWindowLength) 2048
set MVFXVizAttr(dispSpectrogramWindowType) Blackman
set MVFXVizAttr(dispSpectrogramGridColor) yellow

set MVFXVizAttr(dispPitchcurveFrameLength) 0.01
set MVFXVizAttr(dispPitchcurveWindowLength) 0.02
#set MVFXVizAttr(dispPitchcurveWindowLength) 0.0075


#set MVFXVizAttr(dispPitchcurveMaxPitch) 400
#set MVFXVizAttr(dispPitchcurveRefPitch) 110
#set MVFXVizAttr(dispPitchcurveMinPitch) 55
set MVFXVizAttr(dispPitchcurveMaxPitch) 800
set MVFXVizAttr(dispPitchcurveRefPitch) 220 
set MVFXVizAttr(dispPitchcurveMinPitch) 110
set MVFXVizAttr(dispPitchcurveColor) "#ff6060"

set MVFXVizAttr(dispLoudnessColor) "#6060ff"
set MVFXVizAttr(dispLoudnessMIDIThreshold) 48.0
set MVFXVizAttr(dispLoudnessMIDIScaling) 4.5
set MVFXVizAttr(dispLoudnessFrameLength) 0.01
set MVFXVizAttr(dispLoudnessWindowLength) 0.1

set MVFXVizAttr(dispF1CurveColor) "#ff6080"
set MVFXVizAttr(dispF2CurveColor) "#ff60a0"
set MVFXVizAttr(dispF3CurveColor) "#ff60c0"
set MVFXVizAttr(dispF4CurveColor) "#ff60e0"


set MVFXVizAttr(dispScaleMode) second
#set MVFXVizAttr(dispScaleMode) sample  # not implemented
#set MVFXVizAttr(dispScaleMode) beat    # not implemented


set MVFXVizAttr(dispHorizScaleBGColor) "\#484848"
set MVFXVizAttr(dispHorizScaleHeight) 12

set MVFXVizAttr(shuttle,mode) 0

########################################
## "SaveSMF"-related.
########################################
# special thanks to KonekoP's fix: 
# now BPM can be set through a spinbox.
set MVFXMIDIAttr(bpm) 120
set MVFXMIDIAttr(tpq) 480
set MVFXMIDIAttr(meter_numer) 4
set MVFXMIDIAttr(meter_denom) 4



######################################################################
## GUI construction
######################################################################

########################################
## toplevel window
########################################
set w .top
catch {destroy $w}
toplevel $w

## KonekoP says we need "dirty-flag handling"
## Sorry, i don't know much about that! (><)
## Maybe, we need to ask the user if she/he wants to save the unsaved
## changes before closing the application..., I guess.

wm protocol $w WM_DELETE_WINDOW "destroy $w; exit 0"

wm title $w "MVFX Rev.$MVFXSysAttr(MVFXVersion)"
wm iconname $w "MVFX Rev.$MVFXSysAttr(MVFXVersion)"
wm withdraw .



########################################
# menu bar
########################################
set menustatus "  "

menu $w.menu -tearoff 0

set mFile $w.menu.file
menu $mFile -tearoff 0
$mFile add command -label "TEht@CJ...(O)" -command {MVFXCmdLoadSound $w} -underline 15
$mFile add separator
$mFile add command -label "I(Q)" -command "destroy $w; exit 0" -underline 3

set mEdit $w.menu.edit
menu $mEdit -tearoff 0
$mEdit add command -label "Đ()" -command ""

$w.menu add cascade -label "t@C(F)" -menu $mFile -underline 5
$w.menu add cascade -label "ҏW(E)" -menu $mEdit -underline 3
$w configure -menu $w.menu

bind Menu <<MenuSelect>> {
    global $menustatus
    if {[catch {%W entrycget active -label} label]} {
	set label "    "
    }
    set menustatus $label
    update idletasks
}

## Special thanks to KonekoP for the fix:
## ToolBar using BWidget which I've never used... how useful this is!
frame $w.sysToolBar
label $w.sysToolBar.bpm -text "opMIDIBPM:"
SpinBox $w.sysToolBar.spin -range {1 960 1} -textvariable MVFXMIDIAttr(bpm) -width 4 -helptext "bpm"
button $w.sysToolBar.reset -text "120ɃZbg" -command "MVFXMIDICmdSetTempo 120"
pack $w.sysToolBar -fill both
pack $w.sysToolBar.bpm $w.sysToolBar.spin $w.sysToolBar.reset -side left


########################################
# main screen : left-side (panel), right-side(disp)
########################################

#
# tag rules
#
# horizontal scale :    horizScale
# the waveform object :  "snd0" "snd1" ...

frame $w.cframe
canvas $w.cframe.panel \
    -scrollregion \
        "$MVFXVizAttr(panelLeft) $MVFXVizAttr(panelTop) $MVFXVizAttr(panelRight) $MVFXVizAttr(panelBottom)" \
    -width $MVFXVizAttr(panelWinW) \
    -height $MVFXVizAttr(mainWinH) \
    -xscrollcommand "$w.cframe.panelhscroll set" \
    -yscrollcommand "$w.cframe.vscroll set" \
    -xscrollincrement 1 \
    -yscrollincrement 1 \
    -background $MVFXVizAttr(panelBGColor) \
    -relief sunken

canvas $w.cframe.scale \
    -width $MVFXVizAttr(mainWinH) \
    -height $MVFXVizAttr(scaleWinH) \
    -xscrollcommand "$w.cframe.disphscroll set" \
    -xscrollincrement 1 \
    -yscrollincrement 1 \
    -background $MVFXVizAttr(scaleBGColor) 

canvas $w.cframe.disp \
    -scrollregion "$MVFXVizAttr(dispLeft) $MVFXVizAttr(dispTop) $MVFXVizAttr(dispRight) $MVFXVizAttr(dispBottom)" \
    -width $MVFXVizAttr(dispWinW) \
    -height $MVFXVizAttr(mainWinH) \
    -xscrollcommand "$w.cframe.disphscroll set" \
    -yscrollcommand "$w.cframe.vscroll set" \
    -xscrollincrement 1 \
    -yscrollincrement 1 \
    -background $MVFXVizAttr(dispBackGroundColor) \
    -relief sunken

scrollbar $w.cframe.panelhscroll -orient horiz -command "$w.cframe.panel xview"
scrollbar $w.cframe.disphscroll -orient horiz -command "dispHScrollCmd $w"
proc dispHScrollCmd {w args} {
    eval $w.cframe.disp xview $args
    eval $w.cframe.scale xview $args
}
scrollbar $w.cframe.vscroll -command "dispVScrollCmd $w"
proc dispVScrollCmd {w args} {
    eval $w.cframe.panel yview $args
    eval $w.cframe.disp yview $args
}


grid $w.cframe.scale -in $w.cframe \
    -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news

grid $w.cframe.panel -in $w.cframe \
    -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news
grid $w.cframe.disp -in $w.cframe \
    -row 1 -column 1 -rowspan 1 -columnspan 1 -sticky news
grid $w.cframe.vscroll \
    -row 1 -column 2 -rowspan 1 -columnspan 1 -sticky news

grid $w.cframe.panelhscroll \
    -row 2 -column 0 -rowspan 1 -columnspan 1 -sticky news
grid $w.cframe.disphscroll \
    -row 2 -column 1 -rowspan 1 -columnspan 1 -sticky news

grid rowconfig $w.cframe 0 -weight 0
grid rowconfig $w.cframe 1 -weight 1
grid rowconfig $w.cframe 2 -weight 0
grid columnconfig $w.cframe 0 -weight 1
grid columnconfig $w.cframe 1 -weight 4
grid columnconfig $w.cframe 2 -weight 0
pack $w.cframe -side top -fill both -expand yes


########################################
# debug console
########################################
if { 1 } {
    text $w.c -width 80 -height 8 -takefocus 0
    pack $w.c -side top -fill both -expand no
}

proc cClr {} {
    global w
    catch {$w.c delete 0.0 end}
}
proc cPuts {str} {
    global w
    catch {$w.c insert end $str}
}



############################################################
# Mouse-related event - procedure binding
############################################################

##############################
# grasp (will-be-shuttle)
##############################

#   Faced with unexpected technical difficulty, 
#   fulll implementation of shuttling is put off.
#   Instead, simple grasping has been implemented so far,
#   as a good resuming point for shuttling in future. 
#
#   Notes on difficulties in shuttling
#   - Somehow, the "after chain"  was not terminated
#     even if the following  mouse click altered the mode ---
#     Possibly because "after 10" fully occupied
#     the event loop, and was thus unmaskable.
#   - Sometimes a ButtonRelease wasn't caught because
#     the release took place out of w.cframe.disp or
#     even the outside of the application window w.
#   - The after chain must be terminated when the 
#     end of the main display is reached. 
#   One idea is that after-chain stops if dx==dy==0.
#
# shuttle,mode: 0 --- shuttle (grasp) off
# shuttle,mode: 1 --- shuttle (grasp) on

proc MVFXCmdActivateShuttle {w x y} {
    global MVFXVizAttr
    if { $MVFXVizAttr(shuttle,mode) != 1 } {
	set MVFXVizAttr(shuttle,mode) 1
	set MVFXVizAttr(shuttle,prevx) $x
	set MVFXVizAttr(shuttle,prevy) $y
    }
}

# this is called whenever the mouse moves inside w.cframe.disp,
# so status has to be checked 
proc MVFXCmdUpdateShuttle {w x y} {
    global MVFXVizAttr
    if { $MVFXVizAttr(shuttle,mode) != 1 } { return }
    # only when grasped
    set dx [expr int($MVFXVizAttr(shuttle,prevx) - $x)]
    set dy [expr int($MVFXVizAttr(shuttle,prevy) - $y)]
    dispHScrollCmd $w scroll $dx units
    dispVScrollCmd $w scroll $dy units
    set MVFXVizAttr(shuttle,prevx) $x
    set MVFXVizAttr(shuttle,prevy) $y
}

proc MVFXCmdDisactivateShuttle {w x y} {
    global MVFXVizAttr
    set MVFXVizAttr(shuttle,mode) 0
}

bind $w.cframe.disp <Control-ButtonPress-1> "MVFXCmdActivateShuttle $w %x %y"
bind $w.cframe.disp <Control-ButtonRelease-1> "MVFXCmdDisactivateShuttle $w %x %y"



##############################
# vertical cursor
##############################
set MVFXVerticalCursorUpdateMethodIndices {}
array set MVFXVerticalCursorUpdateMethodMap {}

proc MVFXCmdActivateVerticalCursor {w x y} { 
    global MVFXVizAttr
    set canv $w.cframe.disp
    set cx [$canv canvasx $x]
    set cy [MVFXVizNextY $canv]
    $canv create line $cx 0 $cx $cy -dash {2 4} -fill "\#c0c0ff" -tags "vertcursor_line" -state disabled
    set MVFXVizAttr(vertcursor,prevcx) $cx

    set scale $w.cframe.scale
    $scale create line $cx 0 $cx $MVFXVizAttr(scaleWinH) -fill $MVFXVizAttr(scaleHighlightColor) -tags "vertcursor line" -state disabled
    $scale create text \
	$cx $MVFXVizAttr(scaleWinH) \
	-text "0.0" \
	-justify left -anchor sw \
	-font $MVFXVizAttr(scaleFont) \
	-fill $MVFXVizAttr(scaleHighlightColor) \
	-tags "vertcursor loc" -state disabled
}


proc MVFXCmdUpdateVerticalCursor {w x y} { 
    global MVFXVizAttr
    global MVFXVerticalCursorUpdateMethodIndices 
    global MVFXVerticalCursorUpdateMethodMap
    set canv $w.cframe.disp
    set cx [$canv canvasx $x]
    set dx [expr $cx - $MVFXVizAttr(vertcursor,prevcx)]
    $canv move vertcursor_line $dx 0
    $w.cframe.scale move vertcursor $dx 0

    set t [expr ($cx + 0.0) / $MVFXVizAttr(dispPixelsPerSecond) ]
    $w.cframe.scale itemconfigure loc -text [format " %4.4f" $t]
    set MVFXVizAttr(vertcursor,prevcx) $cx

    foreach idx $MVFXVerticalCursorUpdateMethodIndices {
	catch {eval $MVFXVerticalCursorUpdateMethodMap($idx) $t}
#	cPuts "(eval'ed: $MVFXVerticalCursorUpdateMethodMap($idx) $t\n"
    }
}


proc MVFXVerticalCursorAddUpdateMethod { idx methodbody } {
#    global MVFXVizAttr
    global MVFXVerticalCursorUpdateMethodIndices 
    global MVFXVerticalCursorUpdateMethodMap
    lappend MVFXVerticalCursorUpdateMethodIndices $idx
    set MVFXVerticalCursorUpdateMethodMap($idx) $methodbody
#    cPuts "update method added: $methodbody"
}


proc MVFXVerticalCursorDeleteUpdateMethod { idx } {
#    global MVFXVizAttr
    global MVFXVerticalCursorUpdateMethodIndices 
    global MVFXVerticalCursorUpdateMethodMap
    set target [lsearch $MVFXVerticalCursorUpdateMethodIndices $idx]
    if { $target != -1 } {
	set MVFXVerticalCursorUpdateMethodIndices [lreplace $MVFXVerticalCursorUpdateMethodIndices $target $target]
#	cPuts "$target deleted\n"
    }

}


proc MVFXCmdDisactivateVerticalCursor {w x y} { 
    $w.cframe.disp delete vertcursor_line
    $w.cframe.scale delete vertcursor
    $w.cframe.scale delete vertcursor
}

bind $w.cframe.disp <Enter> {MVFXCmdActivateVerticalCursor $w %x %y}
bind $w.cframe.disp <Leave> {MVFXCmdDisactivateVerticalCursor $w %x %y}



##############################
# common binding for grasping and vertical cursor
##############################
bind $w.cframe.disp <Motion> {MVFXCmdUpdateShuttle $w %x %y; MVFXCmdUpdateVerticalCursor $w %x %y}



# when a ripple is added or deleted, this must be called for updated height
# of the vertical cursor
proc MVFXCmdModifyDimensionVerticalCursor {canv} {
    set coords [$canv coords vertcursor_line]
    if { $coords != ""} {
	lset coords 3 [MVFXVizNextY $canv]
	$canv coords vertcursor_line $coords
	$canv raise vertcursor_line
    }
}


##############################
# playback cursor 
##############################
array set MVFXPlaybackCursor {
    isOn 0
    initCx 0
    initClock 0
}

proc MVFXCmdActivatePlaybackCursor {w cx} { 
    global MVFXVizAttr MVFXPlaybackCursor
    set coords [$w.cframe.disp coords vertcursor_line]
    $w.cframe.disp create line $coords -dash {4 2} -fill "\#ffc0c0" -tags "playbackcursor" -state disabled
    set MVFXPlaybackCursor(isOn) 1
    set MVFXPlaybackCursor(initCx) $cx
    set MVFXPlaybackCursor(prevCx) $cx
    set MVFXPlaybackCursor(initClock) [clock clicks -milliseconds] 
    after 30 {MVFXCmdUpdatePlaybackCursor $w}
}

proc MVFXCmdUpdatePlaybackCursor {w} { 
    global MVFXVizAttr MVFXPlaybackCursor
    if { $MVFXPlaybackCursor(isOn) == 0 } {
	$w.cframe.disp delete playbackcursor
	return
    }
    set now [clock clicks -milliseconds]
    set cx [expr int( $MVFXPlaybackCursor(initCx) + $MVFXVizAttr(dispPixelsPerSecond) * ($now - $MVFXPlaybackCursor(initClock)) * 0.001 )]
    $w.cframe.disp move playbackcursor [expr $cx - $MVFXPlaybackCursor(prevCx)] 0 
    set MVFXPlaybackCursor(prevCx) $cx
    after 30 {MVFXCmdUpdatePlaybackCursor $w}
}

proc MVFXCmdDisactivatePlaybackCursor {} { 
    global MVFXPlaybackCursor
    set MVFXPlaybackCursor(isOn) 0
}




########################################
# dialogs
########################################

proc MVFXDialogChooseSoundFile { w } {
    set types {
	{"Sound Files"	{.wav .mp3 .au .snd .aif .sd .smp .csl} }
    }
    return [tk_getOpenFile -filetypes $types -parent $w]
}





########################################
## visualizer
## nextY, updateMainW, will belong to "manager".
## ShowRipple, will be an internal visualizer.
########################################

## return the y coord for the next graphic object to be placed
## c canvas window
## tag the tag for the graphic objects already on the canvas
proc MVFXVizNextY { c } {
    set box [$c bbox "rippleObject"]
    if { $box == "" } {
	return 0
    } else {
	return [expr [lindex $box 3] + 1]
    }
    
}



proc MVFXVizShowRipple { w x0 y0 pps yscale height tags color label timeValuePairs } {
    set canvas $w.cframe.disp
    set tags [lappend tags "rippleObject"]
    set y1 [expr $y0 + $height]
    foreach {t v} $timeValuePairs {
	set x [expr int( $x0 + $t * $pps) ]
	set y [expr int($y1 - $v * $yscale) ]
	lappend polyline $x $y
    }
    set x1 $x
    set id [$canvas create rectangle $x0 $y0 $x1 $y1 -outline $color -fill "" -tags $tags]
    $canvas create line $polyline -fill $color -tags $tags
    MVFXCmdModifyDimensionVerticalCursor $canvas
    
    # register the label
    MVFXVizAddPanelLabel $w 0 $y0 $color $label $label
}





proc MVFXVizUpdateMainW { w widthPixel } {
    global MVFXVizAttr 

    set MVFXVizAttr(dispRight) $widthPixel
    catch {$w.cframe.disp configure -scrollregion \
	       "$MVFXVizAttr(dispLeft) $MVFXVizAttr(dispTop) $MVFXVizAttr(dispRight) $MVFXVizAttr(dispBottom)"}
    set MVFXVizAttr(scaleRight) $widthPixel
    catch {$w.cframe.scale configure -scrollregion \
	       "$MVFXVizAttr(scaleLeft) $MVFXVizAttr(scaleTop) $MVFXVizAttr(scaleRight) $MVFXVizAttr(scaleBottom)"}

    MVFXVizSetHorizScale $w
}


proc MVFXVizSetHorizScale { w } {
    global MVFXVizAttr 
    set pixPerSec $MVFXVizAttr(dispPixelsPerSecond)
    set pixMax $MVFXVizAttr(dispRight)
    set tickTallY [expr $MVFXVizAttr(scaleWinH) - $MVFXVizAttr(scaleTickTall)]
    set tickShortY [expr $MVFXVizAttr(scaleWinH) - $MVFXVizAttr(scaleTickShort)]
    $w.cframe.scale delete all
    for {set t 0; set x 0} {$x <= $pixMax} {set t [expr $t + 1]; set x [expr $x + $pixPerSec]} {
	$w.cframe.scale create text $x $tickTallY -text [format "%3.1f" $t] -justify center -anchor s -font $MVFXVizAttr(scaleFont) -fill $MVFXVizAttr(scaleFGColor) -tags ruler
	$w.cframe.scale create line $x $tickTallY $x $MVFXVizAttr(scaleWinH) -fill $MVFXVizAttr(scaleFGColor) -width 1 -tags ruler
	set x2 [expr $x+$pixPerSec/2]
	$w.cframe.scale create line $x2 $tickShortY $x2 $MVFXVizAttr(scaleWinH) -fill $MVFXVizAttr(scaleFGColor) -width 1 -tags ruler
    }
}


######################################################################
## 
######################################################################

# add a wave form of the sound (sndHdl) to the screen
# (at the bottom)
proc MVFXVizAddWaveform { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr

    # obtain the width of the waveform
    set waveformWidth [expr int($MVFXSndAttr($sndHdl,sec) * $MVFXVizAttr(dispPixelsPerSecond))]

    # update the display dimension (all scrollable)
    MVFXVizUpdateMainW $w $waveformWidth

    # get x0,y0 (top-left corner)
    set x0 0
    set y0 [MVFXVizNextY $w.cframe.disp]
    # generate a waveform and put it in
    $w.cframe.disp create waveform $x0 $y0 -anchor nw \
	-fill $MVFXVizAttr(dispWaveformFillColor) \
	-height $MVFXVizAttr(dispWaveformHeightPixel) \
	-pixelspersecond $MVFXVizAttr(dispPixelsPerSecond) \
	-sound $sndHdl \
	-subsample $MVFXVizAttr(dispWaveformSubsample) \
	-tags "rippleObject $sndHdl $sndHdl,waveform" \
	-frame 1
    MVFXCmdModifyDimensionVerticalCursor $w.cframe.disp

    ########################################
    # create command menu for this
    ########################################
    set menuWin [MVFXVizAddWaveformMenu $w $sndHdl]

    ########################################
    ## binding for the menu
    ########################################
    $w.cframe.disp bind "$sndHdl,waveform" <3> "$menuWin post %X %Y"

    ########################################
    ## binding for playback
    ########################################
    $w.cframe.disp bind "$sndHdl,waveform" <ButtonPress-1> "MVFXCmdPlayStartFrom $w $sndHdl %x %y"
    $w.cframe.disp bind "$sndHdl,waveform" <ButtonRelease-1> "MVFXCmdPlayStop $w $sndHdl"
    $w.cframe.disp bind "$sndHdl,waveform" <Leave> "MVFXCmdPlayStop $w $sndHdl"
}



## english version
if { 0 } {
proc MVFXVizAddWaveformMenu { w sndHdl } {
    ########################################
    # set command menu for this
    ########################################
    set menuWin $w.mWaveform$sndHdl
    menu $menuWin

    $menuWin add command -label "play whole" \
	-command "MVFXSndPlayWhole $w $sndHdl"
    # special thanks to KonekoP for this menu item...
    $menuWin add command -label "process all" \
	-command "MVFXCmdAutomatedProcessing $w $sndHdl"

    $menuWin add command -label "show spectrogram" \
	-command "MVFXCmdShowSpectrogram $w $sndHdl"
    $menuWin add command -label "show pitch" \
	-command "MVFXCmdShowPitch $w $sndHdl"
    $menuWin add command -label "show formant" \
	-command "MVFXCmdShowFormants $w $sndHdl"
    $menuWin add command -label "show loudness" \
	-command "MVFXCmdShowLoudness $w $sndHdl"
    $menuWin add separator
    $menuWin add command -label "ext scope: spectrum" \
	-command "MVFXCmdLoadExternalScopeSpectrum $w $sndHdl"
    $menuWin add separator
    $menuWin add command -label "save Text" \
	-command "MVFXCmdSaveText $w $sndHdl"
    $menuWin add command -label "save SMF" \
	-command "MVFXCmdSaveSMF $w $sndHdl"
    return $menuWin
}
}

# {. ς{łˁDDD
# g`pmenuD
proc MVFXVizAddWaveformMenu { w sndHdl } {
    ########################################
    # set command menu for this
    ########################################
    set menuWin $w.mWaveform$sndHdl
    menu $menuWin

    $menuWin add command -label "ׂčĐ" \
	-command "MVFXSndPlayWhole $w $sndHdl"
    $menuWin add command -label "I[g}`bN" \
	-command "MVFXCmdAutomatedProcessing $w $sndHdl"
    $menuWin add command -label "XyNgO\" \
	-command "MVFXCmdShowSpectrogram $w $sndHdl"
    $menuWin add command -label "sb`\" \
	-command "MVFXCmdShowPitch $w $sndHdl"
    $menuWin add command -label "tH}g\" \
	-command "MVFXCmdShowFormants $w $sndHdl"
    $menuWin add command -label "EhlX\" \
	-command "MVFXCmdShowLoudness $w $sndHdl"
    $menuWin add command -label "XyNgXR[vJ" \
	-command "MVFXCmdLoadExternalScopeSpectrum $w $sndHdl"
    $menuWin add command -label "eLXgۑ" \
	-command "MVFXCmdSaveText $w $sndHdl"
    $menuWin add command -label "MIDIt@Cۑ" \
	-command "MVFXCmdSaveSMF $w $sndHdl"
    return $menuWin
}





# add a label in the panel, and update the scroll-region of the panel
proc MVFXVizAddPanelLabel {w cx cy color label tags} {
    global MVFXVizAttr
    lappend tags "rippleLabel"
    $w.cframe.panel create text $cx $cy \
	-anchor nw \
	-text $label \
	-font $MVFXVizAttr(panelFont) \
	-fill $color \
	-tags $tags

    set MVFXVizAttr(panelRight) [lindex [$w.cframe.panel bbox all] 2]
    catch {$w.cframe.panel configure -scrollregion \
	       "$MVFXVizAttr(panelLeft) $MVFXVizAttr(panelTop) $MVFXVizAttr(panelRight) $MVFXVizAttr(panelBottom)"}
}



proc MVFXVizAddPanelLabelWaveform { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr

    # obtain the filename
    set dirName [file dirname $MVFXSndAttr($sndHdl,filename)]
    set fileName [lindex [file split $MVFXSndAttr($sndHdl,filename)] end]

    # generate a panel label for the waveform, assuming
    # the ripple object for waveform is already created
    set cx 0
    set cy [lindex [$w.cframe.disp bbox $sndHdl,waveform] 1]
    set color $MVFXVizAttr(dispWaveformFillColor)
    set label "$fileName"
    set tags "$sndHdl $sndHdl,waveform"

    MVFXVizAddPanelLabel $w $cx $cy $color $label $tags
}




######################################################################
# CONTROLLER SECTION
######################################################################

# special thanks to KonekoP for this proc.
proc MVFXCmdAutomatedProcessing {w sndHdl} {
	MVFXCmdShowSpectrogram $w $sndHdl
	MVFXCmdShowPitch $w $sndHdl
	MVFXCmdShowFormants $w $sndHdl
	MVFXCmdShowLoudness $w $sndHdl
}


proc MVFXCmdLoadSound { w {at "end"} } {
    set fileName [MVFXDialogChooseSoundFile $w]
    if {$fileName == "" } { return }
    $w configure -cursor watch 
    update
    set sndHdl [MVFXSndFromFile $fileName]
    MVFXVizAddWaveform $w $sndHdl
    MVFXVizAddPanelLabelWaveform $w $sndHdl
    $w configure -cursor arrow
    update
}


proc MVFXCmdPlayStartFrom { w sndHdl x y } {
    global MVFXVizAttr
    set cx [$w.cframe.disp canvasx $x]
    set startpos [expr int( ($cx - 0.0) * [lindex [$sndHdl info] 1] / $MVFXVizAttr(dispPixelsPerSecond))]
    $sndHdl play -start $startpos -blocking 0 -command "MVFXCmdPlayStop $w $sndHdl"
    MVFXCmdActivatePlaybackCursor $w $cx
}

proc MVFXCmdPlayStop { w sndHdl } {
    $sndHdl stop
    MVFXCmdDisactivatePlaybackCursor
}





######################################################################
# MODEL SECTION
######################################################################


########################################
# sound model management
########################################
set MVFXSndAttr(cnt) 0
set MVFXSndAttr(hdls) {}

# obtain a new sound handle; 
# all the handles are recorded in MVFXSndAttr(hdls) .
proc MVFXSndNew {} {
    global MVFXSndAttr
    set sndHdl "snd$MVFXSndAttr(cnt)"
    incr MVFXSndAttr(cnt)
    lappend MVFXSndAttr(hdls) $sndHdl
    return $sndHdl
}

proc MVFXSndFromFile { fileName } {
    global MVFXSysAttr MVFXSndAttr w
    set sndHdl [MVFXSndNew]
    snack::sound $sndHdl -load $fileName

    # make it mono.
    $sndHdl convert -channels 1
    set MVFXSndAttr($sndHdl,filename) $fileName
    set MVFXSndAttr($sndHdl,sec) [$sndHdl length -unit SECONDS]
    return $sndHdl
}


proc MVFXSndPlayWhole { w sndHdl } {
    $sndHdl play 
}


#
# SND, the sound data manager, tracks the spectrumScopes as well
#
proc MVFXSndRegisterSpectrumScope { sndHdl scopeid } {
    global MVFXSndAttr
    if { [catch {lappend MVFXSndAttr($sndHdl,SpectrumScopeIds) $scopeid}] } {
	set MVFXSndAttr($sndHdl,SpectrumScopeIds) [list $scopeid]
    }
}

proc MVFXSndUnregisterSpectrumScope { sndHdl scopeid } {
    global MVFXSndAttr
    set target [lsearch $MVFXSndAttr($sndHdl,SpectrumScopeIds) $scopeid]
    if { $target != -1 } {
	set MVFXSndAttr($sndHdl,SpectrumScopeIds) [lreplace $MVFXSndAttr($sndHdl,SpectrumScopeIds) $target $target]
    }
}



########################################
# spectrogram
########################################
proc MVFXCmdShowSpectrogram { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr
    set x0 0
    set coords [$w.cframe.disp coords $sndHdl,freqplot]
    if {$coords == ""} {
	set y0 [MVFXVizNextY $w.cframe.disp]
    } else {
	set y0 [lindex $coords 1]
    }
    $w.cframe.disp create spectrogram \
	$x0 $y0 -anchor nw \
	-fftlength $MVFXVizAttr(dispSpectrogramFFTLength) \
	-colormap $MVFXVizAttr(dispSpectrogramColorMap) \
	-gridcolor $MVFXVizAttr(dispSpectrogramGridColor) \
	-height $MVFXVizAttr(dispSpectrogramHeightPixel) \
	-pixelspersecond $MVFXVizAttr(dispPixelsPerSecond) \
	-topfrequency $MVFXVizAttr(dispSpectrogramTopFreq) \
	-windowtype $MVFXVizAttr(dispSpectrogramWindowType) \
	-winlength $MVFXVizAttr(dispSpectrogramWindowLength) \
	-sound $sndHdl \
	-tags "rippleObject $sndHdl $sndHdl,spectrogram" 
    $w.cframe.disp create rectangle \
	[$w.cframe.disp bbox $sndHdl,spectrogram] -outline yellow -fill ""\
	-tags "rippleObject $sndHdl $sndHdl,spectrogram"
    catch {$w.cframe.disp lower $sndHdl,spectrogram "$sndHdl"}

    #clicking on the spectrogram will shoot the spectrum 
    $w.cframe.disp bind "$sndHdl,spectrogram" <ButtonPress-1> "MVFXCmdSpectrumShoot $w $sndHdl %x %y"


    ########################################
    # set command menu for spectrogram --- tentative, for multishooting (not implemented yet)
    ########################################
    # menu $w.mSpectrogram$sndHdl
    # $w.mSpectrogram$sndHdl add command -label "multiple shoot" \
	-command "MVFXCmdSpectrumMultiShoot $w $sndHdl %x %y"
    # $w.cframe.disp bind "$sndHdl,spectrogram" <3> "$w.mSpectrogram$sndHdl post %X %Y"

    MVFXCmdModifyDimensionVerticalCursor $w.cframe.disp
}





proc MVFXCmdShowLoudness { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr

    # params
    set framelength $MVFXVizAttr(dispLoudnessFrameLength)
    set windowLength $MVFXVizAttr(dispLoudnessWindowLength)
    
    # get raw loudness using snack functionality
    set loudnessResult \
	[ $sndHdl power \
	      -framelength $framelength \
	      -windowlength [expr int($windowLength * [lindex [$sndHdl info] 1])] \
	      -windowtype Blackman ]

    set minl 128
    set maxl 0
    set idx 0
    foreach loud $loudnessResult {
	set t [expr $idx * $framelength]
	lappend loudnesscurve $t $loud
	incr idx
    }
    set MVFXSndAttr($sndHdl,loudnesscurve,data) $loudnesscurve
    set MVFXSndAttr($sndHdl,loudnesscurve,fromto) "0.0 $t"

    # visualize the loudness curve
    set pps $MVFXVizAttr(dispPixelsPerSecond) 
    set height 64
    set yscale 0.5
    set x0 0
    set y0 [MVFXVizNextY $w.cframe.disp]
    set MVFXSndAttr($sndHdl,loudnesscurve,cy0) $y0
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,loudnesscurve" $MVFXVizAttr(dispLoudnessColor) "loudness(dB)" $loudnesscurve 
}




proc MVFXCmdShowPitch { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr
    set framelength $MVFXVizAttr(dispPitchcurveFrameLength)

    # get raw pitch result using snack functionality
    set pitchResult \
	[ $sndHdl pitch \
	      -method ESPS \
	      -framelength $framelength \
	      -windowlength $MVFXVizAttr(dispPitchcurveWindowLength) \
	      -maxpitch $MVFXVizAttr(dispPitchcurveMaxPitch) \
	      -minpitch $MVFXVizAttr(dispPitchcurveMinPitch) ]

    # results are :
    # ((frequency)
    #  (probability of voicing)
    #  (local root mean squared measurements)
    #  (the peak normalized cross-correlation value))

    # save list in pitchcurve,data; { t0 f0 t1 f1 t2 f2 ... }
    # save list in vocprob; { t0 vp0 t1 vp1 v2 vp2 ... }
    # save list in localrms; { t0 lrms0 t1 lrms1 v2 lrms2 ... }
    # save list in xcorr; { t0 xcorr0 t1 xcorr1 v2 xcorr2 ... }
    
    # time begin/end, lowest freq, highest freq  are saved
    # set min, max to its counter (min <= maximum, max <= minimum)
    set minf $MVFXVizAttr(dispPitchcurveMaxPitch)
    set maxf $MVFXVizAttr(dispPitchcurveMinPitch)
    set idx 0
    set f 0
    foreach rec $pitchResult {
	set t [expr $idx * $framelength]
	# simple smoothing 
	set f [expr 0.7 * [lindex $rec 0] + 0.3 * $f]
	lappend pitchcurve $t $f
	lappend vocprob $t [lindex $rec 1]
	lappend localrms $t [lindex $rec 2]
	lappend xcorr $t [lindex $rec 3]
	if { $f > 0.0 && $f < $minf } { set minf $f }
	if { $f > $maxf } { set maxf $f }
	incr idx
    }
    set MVFXSndAttr($sndHdl,pitchcurve,fromtominmax) "0.0 $t $minf $maxf"
    set MVFXSndAttr($sndHdl,pitchcurve,data) $pitchcurve
    set MVFXSndAttr($sndHdl,vocprob,data) $vocprob
    set MVFXSndAttr($sndHdl,localrms,data) $localrms
    set MVFXSndAttr($sndHdl,xcorr,data) $xcorr

    # visualize the curves... coord-list in pitchLine
    set pps $MVFXVizAttr(dispPixelsPerSecond) 

    # pitch.
    set height $MVFXVizAttr(dispSpectrogramHeightPixel) 
    set yscale [expr (0.0 + $height) /$MVFXVizAttr(dispSpectrogramTopFreq)]
    set x0 0
    set specgrambox [$w.cframe.disp bbox $sndHdl,spectrogram]
    if { $specgrambox == "" } {
	set y0 [MVFXVizNextY $w.cframe.disp]
    } else {
	set y0 [lindex $specgrambox 1]
    }
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,pitchcurve $sndHdl,freqplot" $MVFXVizAttr(dispPitchcurveColor) "pitch::freq" $pitchcurve

    # voc prob.
    set height 64
    set yscale 20.0
    set x0 0
    set y0 [MVFXVizNextY $w.cframe.disp]
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,vocprobcurve" "\#80ffc0" "pitch::voicing probability" $vocprob

    # local rms.
    set height 64
    set yscale 0.01
    set x0 0
    set y0 [MVFXVizNextY $w.cframe.disp]
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,localrmscurve" "\#ffc080" "pitch::local rms" $localrms

    # xcorr
    set height 64
    set yscale 10.0
    set x0 0
    set y0 [MVFXVizNextY $w.cframe.disp]
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,xcorrcurve" "\#c0ff80" "pitch::cross correlation" $xcorr
}


#-windowlength 0.05
#-windowtype cos^4 {hamming/hanning}
#-lpctype  0  (autocorr.)  1 ( stabilized covariance)
#-lpcorder 12
#-ds_freq  10000  (sampling rate for formant freq analysis)
#-nom_f1_freq  500

# results are
# { ( F1 F2 ... B1 B2 ... } 
#   ( F1 F2 ... B1 B2 ... } 
#    ...
#   ( F1 F2 ... B1 B2 ... } }
#  F... freq, B ... band width.
# time begin/end, lowest freq, highest freq  are saved
# set min, max to its counter (min <= maximum, max <= minimum)


# formant
proc MVFXCmdShowFormants { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr
    set framelength $MVFXVizAttr(dispPitchcurveFrameLength)

    # get initial formant result
    set formantResult \
	[ $sndHdl formant \
	      -framelength $framelength \
	      -numformants 4 \
    	      -nom_f1_freq  800 ]

    set idx 0

    foreach rec $formantResult {
	set t [expr $idx * $framelength]
	lappend f1curve $t [lindex $rec 0]
	lappend f2curve $t [lindex $rec 1]
	lappend f3curve $t [lindex $rec 2]
	lappend f4curve $t [lindex $rec 3]
	lappend b1curve $t [lindex $rec 4]
	lappend b2curve $t [lindex $rec 5]
	lappend b3curve $t [lindex $rec 6]
	lappend b4curve $t [lindex $rec 7]
	incr idx
    }
    set MVFXSndAttr($sndHdl,f1curve,data) $f1curve
    set MVFXSndAttr($sndHdl,f2curve,data) $f2curve
    set MVFXSndAttr($sndHdl,f3curve,data) $f3curve
    set MVFXSndAttr($sndHdl,f4curve,data) $f4curve
    set MVFXSndAttr($sndHdl,b1curve,data) $b1curve
    set MVFXSndAttr($sndHdl,b2curve,data) $b2curve
    set MVFXSndAttr($sndHdl,b3curve,data) $b3curve
    set MVFXSndAttr($sndHdl,b4curve,data) $b4curve

    # visualize the curves...
    set pps $MVFXVizAttr(dispPixelsPerSecond) 

    # prepare dimension: identical as pitch display, must be 
    # unified.
    set height $MVFXVizAttr(dispSpectrogramHeightPixel) 
    set yscale [expr (0.0 + $height) /$MVFXVizAttr(dispSpectrogramTopFreq)]
    set x0 0
    set specgrambox [$w.cframe.disp bbox $sndHdl,spectrogram]
    if { $specgrambox == "" } {
	set y0 [MVFXVizNextY $w.cframe.disp]
    } else {
	set y0 [lindex $specgrambox 1]
    }
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,f1curve $sndHdl,freqplot" $MVFXVizAttr(dispF1CurveColor) "formant1" $f1curve
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,f2curve $sndHdl,freqplot" $MVFXVizAttr(dispF2CurveColor) "formant2" $f2curve
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,f3curve $sndHdl,freqplot" $MVFXVizAttr(dispF3CurveColor) "formant3" $f3curve
    MVFXVizShowRipple $w $x0 $y0 $pps $yscale $height "$sndHdl $sndHdl,f4curve $sndHdl,freqplot" $MVFXVizAttr(dispF4CurveColor) "formant4" $f4curve

}



# loudness values are NOT scaled; as is, in dB. 96 - 0.
proc MVFXCmdSaveText { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr

    set types {	{{Text Files}       {.txt}        } }

    # if log-power is below $threshold, it is ignored
    set threshold 45.0
    # expression value is multiplied by this scaling factor
    set expScale 2.5 

    # filename chooser
    set filename [tk_getSaveFile -filetypes $types -defaultextension ".txt"]
    if {"$filename" == ""} {
	return
    }

    # prepare header in tmp text file
    set fd [open $filename "w"]
    set prevPbval ""
    set prevExpval ""

    set pbvalClipped 0
    set expvalClipped 0

    foreach {t f} $MVFXSndAttr($sndHdl,pitchcurve,data) {tdummy l} $MVFXSndAttr($sndHdl,loudnesscurve,data) {
	if { $t == "" || $tdummy == "" } { break }
	puts $fd [format "%8.3f\t%8.3f\t%8.3f" [expr $t * 1000.0] $f $l]
    }
    close $fd
    tk_messageBox -icon info -message "$filename created.\n" -type ok -parent $w
}


##############################
# save SMF
##############################

proc MVFXMIDICmdSetTempo { bpm } {
    global MVFXMIDIAttr
    set MVFXMIDIAttr(bpm) $bpm
}




#
# expression (loudness  value) is scaled.
#
# t2mfClong file name ȑOɃrhꂽ̂炵C
# fBNg󂯕tȂ͗lłc
# - TclŁCtemporary filêfBNgɈړexecD
# - execɂ͒Ztemporary filêݗ^D
# - t@C̈ړȂǂtcl fileR}h(long file name ok).
# Ƃ悤ɂĂ݂܂D
#
# ̕C conime tH_/t@CĂ܂
# 񂩂fileȂȂƂƂĂ܂D
# Ήl܂D

proc MVFXCmdSaveSMF { w sndHdl } {
    global MVFXSysAttr MVFXSndAttr MVFXVizAttr MVFXMIDIAttr

    ## Make sure working files can be created
    ## Special thanks to KonekoP for the fix: files are now
    ## specified in fullpath.
    set tmptxtfile T1.TXT
    set tmpmidfile T2.MID
    set tmptxtfile_full [file nativename $MVFXSysAttr(dir)/$tmptxtfile]
    set tmpmidfile_full [file nativename $MVFXSysAttr(dir)/$tmpmidfile]
    file delete "$tmpmidfile_full"
    file delete "$tmptxtfile_full"

    # choose the SMF filename to be saved
    set types {	{{Standard MIDI Files}       {.mid}        } }
    set filename [tk_getSaveFile -filetypes $types -defaultextension ".mid"]
    if {"$filename" == ""} {
	return
    }

    # open the text file
    set fd [open $tmptxtfile_full "w"]

    ## params
    set BPM $MVFXMIDIAttr(bpm)
    set TPQ $MVFXMIDIAttr(tpq)
    set meter "$MVFXMIDIAttr(meter_numer)/$MVFXMIDIAttr(meter_denom)"
    set refnote $MVFXVizAttr(dispPitchcurveRefPitch)

    ## midi channel is 1-origin in t2mf.
    set midich 1

    ## expression value is multiplied by this scaling factor.
    ## if log-power is below $threshold, it is ignored.
    set expThreshold $MVFXVizAttr(dispLoudnessMIDIThreshold)
    set expScale $MVFXVizAttr(dispLoudnessMIDIScaling)

    # prepare header in tmp text file
    set UsecPerBeat [expr int(60.0* 1000000 / $BPM)]

    puts $fd "MFile 1 1 $MVFXMIDIAttr(tpq)"
    puts $fd "MTrk"
    puts $fd "0 Meta TrkName \"pitchbend\""
    puts $fd "0 Tempo $UsecPerBeat"
    puts $fd "0 TimeSig $MVFXMIDIAttr(meter_numer)/$MVFXMIDIAttr(meter_denom) 24 8"
    puts $fd "0 Par ch=$midich c=101 val=0"
    puts $fd "0 Par ch=$midich c=100 val=0"
    puts $fd "0 Par ch=$midich c=6 val=24"

    set logRefnote [expr log( $refnote )]
    set log2recip [expr 1.0/log(2.0)]
    set prevPbval ""
    set prevExpval ""

    set pbvalClipped 0
    set expvalClipped 0

    foreach {t f} $MVFXSndAttr($sndHdl,pitchcurve,data) {tdummy l} $MVFXSndAttr($sndHdl,loudnesscurve,data) {
	if { $t == "" || $tdummy == "" } { break }
	set tick  [expr int( $t * 1000000 / $UsecPerBeat * $TPQ )]

	# calc pitchbend value for $f
	if { $f == 0.0 } {
	    set pbval 0
	} else {
	    set pbval [expr int( (log( $f ) - $logRefnote) * $log2recip * 4096) ]
	    if { $pbval < -8192 } { set pbval -8192; set pbvalClipped 1 }
	    if { $pbval > 8191 } { set pbval 8191; set pbvalClipped 1 }
	}
	set pbval [expr $pbval + 8192]

	# calc expression value for $l (threshold already applied)
	set expval [expr int( $expScale * ($l - $expThreshold ) )]
	if { $expval < 0 } { set expval 0 }
	if { $expval > 127 } { set expval 127; set expvalClipped 1 }
	
	#output
	if { "$prevPbval" != $pbval } {
	    puts $fd "$tick Pb ch=$midich v=$pbval"
	    set prevPbval $pbval
	}

	if { "$prevExpval" != $expval } {
	    puts $fd "$tick Par ch=$midich c=11 v=$expval"
	    set prevExpval $expval
	}
    }

    if { $pbvalClipped } {
	cPuts "pitch clipped.\n"
    }
    if { $expvalClipped } {
	cPuts "loudness clipped.\n"
    }

    puts $fd "$tick Meta TrkEnd"
    puts $fd "TrkEnd"
    close $fd


    # special thanks to KonekoP : now t2mf is executed in the temp-file-dir.
    # ݂̃fBNgۑŃe|t@ĈfBNgcd
    set MVFXSysAttr(cwd) [pwd]
    cd $MVFXSysAttr(dir)

    # Since t2mf is executed IN the directory where the temp. files
    # reside, file name bodies without the path are specified:
    if { [catch {exec t2mf.exe "$tmptxtfile" "$tmpmidfile"} msg] } {
	file delete "$tmptxtfile"
	file delete "$tmpmidfile"
	tk_messageBox -icon info -message "t2mf error: $msg\n" -type ok -parent $w
	cd $MVFXSysAttr(cwd)
#	cPuts "now returned to: $MVFXSysAttr(cwd)\n"
	return 
    }
    # special thanks to KonekoP's KonekoFix
    # ĂтƂ̃fBNgɖ߂
    # ňقȂfBNgɕۑۂɂ삷͂
    cd $MVFXSysAttr(cwd)


#    cPuts "now returned to: $MVFXSysAttr(cwd)\n"
    file delete "$tmptxtfile_full"
#    cPuts "moving $tmpmidfile_full to $filename\n"
    file rename -force "$tmpmidfile_full" "$filename"
    tk_messageBox -icon info -message "$filename created.\n" -type ok -parent $w
}




##############################
## more command handlings : 
## a trial towards plug-in style visualizer 
##
## 1) menu-command creates a viewer.
## 2) the menu-command registers the calls to the viewer inside the system
##    (e.g.  vertical cursor for position-update, sound-objects for snapshooting)
## 3) events (motion or mouse click) triggers a command-handling,
## 4) it executes the calls.
## 5) when the viewer is closed, the calls are deleted.
##############################


########################################
## external scopes 
## 
## system will assign
## w.extscope.snd$sndHdl.scopename$cnt
## and open the pane as an independent window
########################################

#### implementation note
#### In future, the following sections will be in a separate
#### file, forming a package. 
#### this will serve as a plug-in, called in a unified manner
#### from the section below these.
#### virtual beginning of the plug-in file

array set SpectrumScopeAttr {}

## issue a new id for the scope.
## combined with sndHdl, this will make a unique id ---
## "$sndHdl$id", for instance.
## it is the caller-side responsibility to specify the
## window path for this scope, because it can't be
## hard-coded inside this module.
proc SpectrumScopeNewId {} {
    global SpectrumScopeAttr
    if { [catch {set cnt $SpectrumScopeAttr(cnt)}] } {
	set SpectrumScopeAttr(cnt) 0
    }
    set specScopeId $SpectrumScopeAttr(cnt)
    incr SpectrumScopeAttr(cnt)
    return $specScopeId
}

##
## this is called once to open the window
##
## SpectrumScope canvas layer design
## "$spec_id_lpc" master spectrum objects (LPC/FFT)  created by snack  
## ,master_spec   
##                master labels
##                image of snapshot #1         :  tags: "SpecScopeSnap_$specScopeId_$snapCnt" "snap$snapCnt" "img"
##                labels for snapshot #1       .  tags: "SpecScopeSnap_$specScopeId_$snapCnt" "snap$snapCnt" "label"
##                image of snapshot #2         .
##                labels for snapshot #2       :
## "screen"       BLACK SCREEN                 
##                image of snapshot #n1        :  
##                labels for snapshot #n1      .  hidden snapshots
## "shutter"      SHUTTER : to be placed just below the master spectrum when shooting

proc SpectrumScopeOpen { specScopeId scopewin sndHdl w h} {
    global SpectrumScopeAttr 
    global SpectrumScopeVarLPCOn$specScopeId
    global SpectrumScopeVarFFTOn$specScopeId

    set fmax 22050
    set fmin 0

    catch {destroy $scopewin}
    toplevel $scopewin
    wm title $scopewin "SpectrumScope"
    wm iconname $scopewin "SpectrumScope"
    wm protocol $scopewin WM_DELETE_WINDOW "SpectrumScopeClose $specScopeId "

    # display stack  : snapshot chooser/layer editor
    frame $scopewin.stack
    pack $scopewin.stack -side right -expand yes -fill both
    label $scopewin.stack.title -text "display stack" -justify center
    pack $scopewin.stack.title -side top 
    scrollbar $scopewin.stack.scroll -command "$scopewin.stack.list yview"
    listbox $scopewin.stack.list -yscroll "$scopewin.stack.scroll set" -setgrid 1 -height 12 -selectmode multiple
    $scopewin.stack.list insert end "<hidden>"
    set SpectrumScopeAttr($specScopeId,numShownSnaps) 0
    pack $scopewin.stack.scroll -side right -fill y
    pack $scopewin.stack.list -side left -expand 1 -fill both

    # menu for the stack list
    menu $scopewin.stack.mList
    $scopewin.stack.mList add command -label "delete" \
	-command "SpectrumScopeDeleteSelected $specScopeId $scopewin $sndHdl"
    $scopewin.stack.mList add command -label "transparent" \
	-command "SpectrumScopeMakeTransparentSelected $specScopeId $scopewin $sndHdl"
    bind $scopewin.stack.list <3> "$scopewin.stack.mList post %X %Y"
    bind $scopewin.stack.list <ButtonPress-1> "SpectrumScopeMoveLayerOn $specScopeId $scopewin $sndHdl %x %y"
    bind $scopewin.stack.list <ButtonRelease-1> "SpectrumScopeMoveLayerOff $specScopeId $scopewin $sndHdl %x %y"
    bind $scopewin.stack.list <Leave> "SpectrumScopeMoveLayerCancel $specScopeId $scopewin $sndHdl %x %y"

    # title part.
    label $scopewin.title -text "" -font {Helvetica 12} -justify center
    pack $scopewin.title -side top -fill x

    # graph part.
    frame $scopewin.graph
    frame $scopewin.graph.axisx
    label $scopewin.graph.axisx.max -text "$fmax/Hz" -anchor ne -justify right
    label $scopewin.graph.axisx.min -text "$fmin" -anchor nw -justify left
    pack $scopewin.graph.axisx.max -side right -fill x
    pack $scopewin.graph.axisx.min -side left -fill x
    frame $scopewin.graph.axisy
    label $scopewin.graph.axisy.max -text "0/dB" -anchor ne -justify right
    label $scopewin.graph.axisy.min -text "-100" -anchor se -justify right
    pack $scopewin.graph.axisy.max -side top
    pack $scopewin.graph.axisy.min -side bottom
    canvas $scopewin.graph.c -width $w -height $h -bg \#000000 -highlightthickness 0 -bd 0

    grid $scopewin.graph.axisy -in $scopewin.graph \
	-row 0 -column 0 -rowspan 1 -columnspan 1 -sticky nes
    grid $scopewin.graph.c -in $scopewin.graph \
	-row 0 -column 1 -rowspan 1 -columnspan 1 -sticky ws
    grid $scopewin.graph.axisx -in $scopewin.graph \
	-row 1 -column 1 -rowspan 1 -columnspan 1 -sticky new
    pack $scopewin.graph -side top

    # inside the canvas, prepare shutters (see the description above the proc)
    $scopewin.graph.c create rectangle 0 0 [expr $w-1] [expr $h-1] -fill black -tags "shutter"
    $scopewin.graph.c create rectangle 0 0 [expr $w-1] [expr $h-1] -fill black -tags "screen"
    $scopewin.graph.c lower "shutter" "screen" 
    

    # time display / lpc, fft switch
    frame $scopewin.f
    label $scopewin.f.time -text "" -font {Helvetica 12}
    label $scopewin.f.sample -text "" -font {Helvetica 12}
    checkbutton $scopewin.f.lpc_on -text "LPC" -variable SpectrumScopeVarLPCOn$specScopeId
    checkbutton $scopewin.f.fft_on -text "FFT" -variable SpectrumScopeVarFFTOn$specScopeId
    $scopewin.f.lpc_on select
    pack $scopewin.f.time $scopewin.f.sample -side left
    pack $scopewin.f.lpc_on $scopewin.f.fft_on -side right
    pack $scopewin.f -side top

    # save important information
    set SpectrumScopeAttr($specScopeId,win) $scopewin
    set SpectrumScopeAttr($specScopeId,sndHdl) $sndHdl
    set SpectrumScopeAttr($specScopeId,width) $w
    set SpectrumScopeAttr($specScopeId,height) $h
    set SpectrumScopeAttr($specScopeId,spec_id_lpc) "dummy"
    set SpectrumScopeAttr($specScopeId,spec_id_fft) "dummy"
    set SpectrumScopeAttr($specScopeId,snapCnt) 0
    set SpectrumScopeAttr($specScopeId,color) [Colors_rgbToColorCode [Colors_hsvToRgb 0 0.5 0.9]]
    set SpectrumScopeAttr($specScopeId,MoveLayerIsOn) 0
    set SpectrumScopeAttr($specScopeId,MoveLayerTarget) 0
}


proc SpectrumScopeSetTitle { specScopeId title } {
    global SpectrumScopeAttr
    set scopewin $SpectrumScopeAttr($specScopeId,win)
    $scopewin.title configure -text $title
}

proc SpectrumScopeGetColor { specScopeId } {
    global SpectrumScopeAttr
    return $SpectrumScopeAttr($specScopeId,color)
}

proc SpectrumScopeSetColor { specScopeId color } {
    global SpectrumScopeAttr
    set SpectrumScopeAttr($specScopeId,color) $color
}


proc SpectrumScopeUpdate { specScopeId t } {
    global SpectrumScopeAttr 
    upvar #0 SpectrumScopeVarLPCOn$specScopeId lpcOn
    upvar #0 SpectrumScopeVarFFTOn$specScopeId fftOn
#    cPuts "spectrumScopeUpdate came: id=$specScopeId t=$t\n"

    set win $SpectrumScopeAttr($specScopeId,win)
    set sndHdl $SpectrumScopeAttr($specScopeId,sndHdl)
    set height $SpectrumScopeAttr($specScopeId,height)
    set width $SpectrumScopeAttr($specScopeId,width)
    set color $SpectrumScopeAttr($specScopeId,color)

    set fs [lindex [$sndHdl info] 1]
    set start_sample [expr int( $fs * $t )]
    set old_id_lpc $SpectrumScopeAttr($specScopeId,spec_id_lpc) 
    set old_id_fft $SpectrumScopeAttr($specScopeId,spec_id_fft) 

    $win.f.time configure -text [format "TIME(sec): %8.3f" $t] -font {Helvetica 12}
    $win.f.sample configure -text [format "SAMPLE(num): %8d" [expr int($t * $fs)] ] -font {Helvetica 12}
    if { $lpcOn } {
	set spec_id_lpc [$win.graph.c create section 0 0 -fill $color -frame 0\
			     -height $height -width $width \
			     -analysistype LPC \
			     -lpcorder 32 \
			     -winlength 512 \
			     -maxvalue 0 -minvalue -100 \
			     -sound $sndHdl \
			     -start $start_sample -end [expr $start_sample+2048] ]
	$win.graph.c addtag "master_spec" withtag $spec_id_lpc
	set SpectrumScopeAttr($specScopeId,spec_id_lpc) $spec_id_lpc
	
    } 
    if { $fftOn } {
	set spec_id_fft [$win.graph.c create section 0 0 -fill $color -frame 0\
			     -height $height -width $width \
			     -analysistype FFT \
			     -fftlength 128 \
			     -winlength 128 \
			     -maxvalue 0 -minvalue -100 \
			     -sound $sndHdl \
			     -start $start_sample -end [expr $start_sample+2048] ]
	$win.graph.c addtag "master_spec" withtag $spec_id_fft
	set SpectrumScopeAttr($specScopeId,spec_id_fft) $spec_id_fft
    } 
    $win.graph.c delete $old_id_lpc $old_id_fft
}
#-channel channel 
#-debug level 
#-start sample 
#-end sample 
#-fftlength length 
#-fill color 
#-frame boolean 
#-height size 
#-lpcorder n 
#-maxvalue value 
#-minvalue value 
#-preemphasisfactor factor 
#-skip points 
#-sound name 
#-stipple value 
#-tags tagList 
#-topfrequency frequency 
#-width size 
#-windowtype type 
#-winlength length 


proc SpectrumScopeShoot {specScopeId} {
    global SpectrumScopeAttr 
    set win $SpectrumScopeAttr($specScopeId,win)

    # get a new "snapHdl" for the snapshot
    # within this spec scope. (the following two lines
    # are better in a procedure)
    set snapHdl $SpectrumScopeAttr($specScopeId,snapCnt)
    incr SpectrumScopeAttr($specScopeId,snapCnt)

    # generate color for the next drawing
    set prevColor [SpectrumScopeGetColor $specScopeId]
    set color [Colors_rgbToColorCode [Colors_hsvToRgb [expr ($SpectrumScopeAttr($specScopeId,snapCnt) % 8)*360.0/8]  0.5 0.9]]
    SpectrumScopeSetColor $specScopeId $color

    # ... to build the image resource name for this snapshot.
    # the image resource is global, so scope-id is added for 
    # global identity
    set name [format "SpecScopeSnap_%s_%s" $specScopeId $snapHdl]

    # have masters (lpc/fft)  on top, followed by shutter
    $win.graph.c raise "master_spec"
    $win.graph.c lower shutter master_spec
    wm attributes $win -topmost 1
    update

    # SHOOT the master images!!!
    # Note that if a part of the spectrumscope is hidden,
    # then such a part will appear as a blank section in the image.
    # this is the limitation of img::window implementation.
    image create photo $name -data $win.graph.c

    # put back the shutter to the bottom layer (so it gets hidden)
    $win.graph.c lower shutter

    # show the newly obtained snapshot at the top.
    $win.graph.c create image 0 0 -anchor nw -image $name -tags [list $name snap$snapHdl img] 
#    cPuts "image created with tags=[list $name snap$snapHdl img]\n"

    #register the new snapshot to the snap stack
    set itemname "$snapHdl: [lindex [$win.f.time configure -text] 4 ]"
    set SpectrumScopeAttr($specScopeId,$snapHdl,imgname) $name
    $win.stack.list insert 0 $itemname
    $win.stack.list itemconfigure 0 -bg $prevColor -selectbackground $prevColor  -selectforeground white
    incr SpectrumScopeAttr($specScopeId,numShownSnaps)
    update
}

    
#
# make the specified items in the list transparent:
# 
# VERY SLOW, scanning the entire image pixel-by-pixel :-(
# 
proc SpectrumScopeMakeTransparentSelected { specScopeId scopeWin sndHdl } {
    global SpectrumScopeAttr
    set listWin $scopeWin.stack.list

    foreach idx [lsort -decreasing -integer [$listWin curselection]] {
	if {[regexp {^([0-9]+):} [$listWin get $idx] dummy snapHdl]} {
	    set imgname $SpectrumScopeAttr($specScopeId,$snapHdl,imgname)

	    #I know this is extremely slow.... however I don't know
	    #the fast way. There should be a way to, say, convert
	    # the image to gif or png, set the transparent color as gif/png,
	    # then have it back. 
	    set width [image width $imgname]
	    set height [image height $imgname]
	    for { set y 0 } { $y < $height } {incr y} {
		for { set x 0 } { $x < $width } { incr x } {
		    $imgname transparency set $x $y [string equal "[$imgname get $x $y]" "0 0 0"]
		}
	    }
	}
    }
    update
}

    
proc SpectrumScopeDeleteSelected { specScopeId scopeWin sndHdl } {
    global SpectrumScopeAttr
    set listWin $scopeWin.stack.list
    foreach idx [lsort -decreasing -integer [$listWin curselection]] {
	if {[regexp {^([0-9]+):} [$listWin get $idx] dummy snapHdl]} {
	    set imgname $SpectrumScopeAttr($specScopeId,$snapHdl,imgname)
	    $scopeWin.graph.c delete $imgname
	    image delete $imgname
	    $listWin delete $idx
#	    cPuts "delete: idx=$idx : snapHdl=$snapHdl : imgname=$imgname \n"
#	    cPuts "[image names]\n"
	}
    }
    update
}


proc SpectrumScopeMoveLayerOn { specScopeId scopewin sndHdl x y } {
    global SpectrumScopeAttr
    set SpectrumScopeAttr($specScopeId,MoveLayerIsOn) 1
    set SpectrumScopeAttr($specScopeId,MoveLayerTarget) [$scopewin.stack.list nearest $y]
    cPuts "layer on : $specScopeId $sndHdl $x $y => index=$SpectrumScopeAttr($specScopeId,MoveLayerTarget)\n"
}


proc SpectrumScopeMoveLayerOff { specScopeId scopewin sndHdl x y } {
    global SpectrumScopeAttr
    if { $SpectrumScopeAttr($specScopeId,MoveLayerIsOn)  } {
	set listwin $scopewin.stack.list
	set newidx [$listwin nearest $y]
	set oldidx $SpectrumScopeAttr($specScopeId,MoveLayerTarget)
	set itemname [$listwin get $oldidx]
	set bgcolor [$listwin itemcget $oldidx -bg]
	
	$listwin insert $newidx $itemname
	$listwin itemconfigure $newidx -bg $bgcolor -selectbackground $bgcolor -selectforeground white
	if { $oldidx > $newidx } { incr oldidx }
	$listwin delete $oldidx
	
	# rearrange the order of all the snapshots following the list!
	for { set idx [expr [$listwin size]-1]} {$idx >= 0} {set idx [expr $idx-1]} {
	    if {[regexp {^([0-9]+):} [$listwin get $idx] dummy snapHdl]} {
		set imgname $SpectrumScopeAttr($specScopeId,$snapHdl,imgname)
		$scopewin.graph.c raise $imgname
	    } else {
		$scopewin.graph.c raise screen
	    }
	}
	$scopewin.graph.c raise master_spec
	set SpectrumScopeAttr($specScopeId,MoveLayerIsOn) 0
    }	
    cPuts "layer off : $specScopeId $sndHdl $x $y\n"
}

proc SpectrumScopeMoveLayerCancel { specScopeId scopewin sndHdl x y } {

    set SpectrumScopeAttr($specScopeId,MoveLayerIsOn) 0
    cPuts "layer cancel : $specScopeId $sndHdl $x $y\n"
}


proc SpectrumScopeClose { specScopeId } {
    global SpectrumScopeAttr
    destroy $SpectrumScopeAttr($specScopeId,win)
    ## the code below is not good ...  
    ## a viewer, spectrumScope, must not assume the specific structure
    ## or methods like these....
    MVFXVerticalCursorDeleteUpdateMethod $SpectrumScopeAttr($specScopeId,win)
    MVFXSndUnregisterSpectrumScope $SpectrumScopeAttr($specScopeId,sndHdl) $specScopeId
}




####################
# spectrum scope
####################

proc MVFXCmdLoadExternalScopeSpectrum { w sndHdl } {
    global MVFXSndAttr
    set scopeid [SpectrumScopeNewId]
    set scopewin [format "%s%s%s" "$w.specscope" "_$sndHdl" "_$scopeid"]
    SpectrumScopeOpen $scopeid $scopewin $sndHdl 512 300
    SpectrumScopeSetTitle $scopeid [lindex [file split $MVFXSndAttr($sndHdl,filename)] end]
    MVFXVerticalCursorAddUpdateMethod $scopewin "SpectrumScopeUpdate $scopeid"

    MVFXSndRegisterSpectrumScope $sndHdl $scopeid
}


proc MVFXCmdSpectrumShoot { w sndHdl x y } {
    global MVFXSndAttr
    # when there are no SpectrumScope objects, an error
    # is raised --- which is caught by "catch".
    catch {
	foreach scopeid $MVFXSndAttr($sndHdl,SpectrumScopeIds) {
	    SpectrumScopeShoot $scopeid
	}
    }
}





######################################################################
## Initialization
######################################################################

## draw the default horizontal scale
MVFXVizSetHorizScale $w
# cPuts "now at: $MVFXSysAttr(dir)\n"
